#!/root/tmp/php-src/sapi/cli/php
<?

/*

simple NS_Shared_Object and Nanoserv::Fork() example

this program outputs :

[14371] master process launched, forking
[14372] child process launched
[14371] setting value to 50
[14372] $so->value = 50
[14371] setting value to 100
[14372] $so->value = 100
[14371] setting value to 150
[14372] $so->value = 150
[14371] setting value to 200
[14372] $so->value = 200
[14371] setting value to 250
[14372] $so->value = 250
[14371] setting value to 300
[14372] $so->value = 300
[14371] setting value to 350
[14372] $so->value = 350
[14371] setting value to 400
[14372] $so->value = 400
[14371] setting value to 450
[14372] $so->value = 450
[14371] setting value to 500
[14372] $so->value = 500
[14371] 1100 IPC calls in 0.52 sec.

*/

require "nanoserv/nanoserv.php";

function pecho($s) {

	echo "[".posix_getpid()."] {$s}\n";

}

class foo {

	public $value = 0;

	public function set($v) {

		if (!($v % 50)) pecho("setting value to {$v}");

		$this->value = $v;

	}

	public function done($t) {

		pecho("1100 IPC calls in ".sprintf("%.2f", $t)." sec.");
		exit();

	}

}

$o = new foo();
$so = Nanoserv::New_Shared_Object($o);

pecho("master process launched, forking");

if (Nanoserv::Fork() > 0) Nanoserv::Run();

pecho("child process launched");

$t = microtime(true);

for ($a=1; $a<=500; $a++) {

	$so->set($a);

	$test = $so->value;

	if ($test != $a) pecho("ERROR: $test != $a");

	if (!($a % 50)) pecho('$so->value = '.$so->value);

}

$so->done(microtime(true) - $t);

?>
