#!/usr/local/bin/php
<?

require "nanoserv/nanoserv.php";
require "nanoserv/handlers/NS_HTTP_Service_Handler.php";

class NS_httpd extends NS_HTTP_Service_Handler {

	private $docroot;

	public function __construct($docroot) {

		$this->docroot = $docroot;

	}
	
	public function on_Request($url) {

		$cfn = realpath($this->docroot.DIRECTORY_SEPARATOR.$url);

		if ((strpos($cfn, $this->docroot) !== 0) || (!is_readable($cfn))) {

			$this->Set_Response_Status(404);
			return "<h1>Not Found</h1>";

		} else {

			if (is_dir($cfn)) {

				foreach (scandir($cfn) as $dname) {

					if ($dname == ".") continue;

					$ret .= "<a href='".addslashes($url.($url{strlen($url)-1} != "/" ? "/" : "").$dname)."'>".$dname."</a><br>";

				}

				$ret .= "<br><hr><font size='1'>nanoserv/".NS_VERSION."</font>";

				return $ret;

			} else {

				if ((is_callable("mime_content_type")) && ($ct = mime_content_type($cfn))) $this->Set_Content_Type($ct);

echo "{$cfn} : ".mime_content_type($cfn)."\n";

				return file_get_contents($cfn);

			}

		}

	}

}

$docroot = realpath($argv[1]) or die("usage: ".$argv[0]." /path/to/document/root\n");

Nanoserv::New_Listener("tcp://0.0.0.0:800", "NS_httpd", $docroot)->Activate();

$ssl = Nanoserv::New_Listener("ssl://0.0.0.0:443", "NS_httpd", $docroot);

$ssl->Set_Option("ssl", "local_cert", "/etc/ssl/certs/nanoweb.pem");
$ssl->Set_Forking();
$ssl->Activate() or die("unable to activate ssl listener");

Nanoserv::Run();

?>
